summaryrefslogtreecommitdiff
path: root/tests/chmod/c-option
diff options
context:
space:
mode:
Diffstat (limited to 'tests/chmod/c-option')
-rwxr-xr-xtests/chmod/c-option67
1 files changed, 67 insertions, 0 deletions
diff --git a/tests/chmod/c-option b/tests/chmod/c-option
new file mode 100755
index 0000000..bf2c4a9
--- /dev/null
+++ b/tests/chmod/c-option
@@ -0,0 +1,67 @@
+#!/bin/sh
+# Verify that chmod's --changes (-c) option works.
+
+# Copyright (C) 2000, 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chmod --version
+fi
+
+. $srcdir/../lang-default
+
+pwd=`pwd`
+tmp=c-option.$$
+trap 'status=$?; cd "$pwd" && rm -rf $tmp && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+framework_failure=0
+
+# Record absolute path of srcdir.
+cd $srcdir || framework_failure=1
+abs_srcdir=`pwd`
+
+cd "$pwd" || framework_failure=1
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+umask 0
+file=f
+touch $file || framework_failure=1
+chmod 444 $file || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo 'failure in testing framework'
+ (exit 1); exit 1
+fi
+
+. "$abs_srcdir/../setgid-check"
+
+fail=0
+
+chmod u=rwx $file || fail=1
+chmod -c g=rwx $file > out || fail=1
+chmod -c g=rwx $file > empty || fail=1
+
+test -s empty && fail=1
+case "`cat out`" in
+ "mode of \`f' changed to 0774 "?rwxrwxr--?) ;;
+ *) fail=1 ;;
+esac
+
+(exit $fail); exit $fail